import sys
import os
import glob
import matplotlib.pyplot as plt
# Local
from pyFAST.linearization.linearization import plotCampbellDataFile


if len(sys.argv) not in [2,3,4]:
    print(""" 
usage:
    plotCampbellData XLS_OR_CSV [WS_OR_RPM] [sheetname] 

where:
    - XLS_OR_CSV: is an Excel file, or the ModesID CSV file generated by the matlab 
           postprocessing of the linearization.
           The "ModesID" CSV file can have any name, but the remaining csv files
           are assumed to be [Campbell_Points*.csv  and Campbell_OP.csv]
           in the same folder of the "ModesID" csv.

    - WS_OR_RPM: is `ws` or `rpm` (case insensitive), value use for  x-axis

    - sheetname: optional argument to specify the ModesID sheet of the xls file.
""")
    sys.exit(-1)

    
# --- Input handling
xls_or_csv = sys.argv[1]
if len(sys.argv)>=3:
    ws_or_rpm  = sys.argv[2]
else:
    ws_or_rpm  = 'rpm'
if len(sys.argv)>=4:
    sheetname = sys.argv[3]
else:
    sheetname = None

fig, axes, figName = plotCampbellDataFile(xls_or_csv, ws_or_rpm, sheetname, ylim=None)
print('Figure saved to:',figName)
fig.savefig(figName, dpi=300)
plt.show()
